"use client"
import { zodResolver } from "@hookform/resolvers/zod"
import { parsePhoneNumberFromString } from "libphonenumber-js"
import { useCallback, useEffect, useMemo } from "react"
import { FormProvider, useForm } from "react-hook-form"
import { useIntl } from "react-intl"

import { useEnterDetailsStore } from "@/stores/enter-details"

import SpecialRequests from "@/components/HotelReservation/EnterDetails/Details/SpecialRequests"
import CountrySelect from "@/components/TempDesignSystem/Form/Country"
import Input from "@/components/TempDesignSystem/Form/Input"
import Phone from "@/components/TempDesignSystem/Form/Phone"
import Footnote from "@/components/TempDesignSystem/Text/Footnote"
import { useFormTracking } from "@/components/TrackingSDK/hooks"
import { useRoomContext } from "@/contexts/Details/Room"

import MemberPriceModal from "../MemberPriceModal"
import JoinScandicFriendsCard from "./JoinScandicFriendsCard"
import { getMultiroomDetailsSchema } from "./schema"

import styles from "./details.module.css"

const formID = "enter-details"
export default function Details() {
  const intl = useIntl()

  const { addPreSubmitCallback, rooms } = useEnterDetailsStore((state) => ({
    addPreSubmitCallback: state.actions.addPreSubmitCallback,
    rooms: state.rooms,
  }))

  const {
    actions: { updateDetails, setIncomplete },
    idx,
    room,
    roomNr,
  } = useRoomContext()
  const initialData = room.guest

  /**
   * The data that each room needs from each other to do validations
   * across the rooms
   */
  const crossValidationData = useMemo(
    () =>
      rooms
        .filter((_, i) => i !== idx)
        .map((room) => ({
          firstName: room.room.guest.firstName,
          lastName: room.room.guest.lastName,
          membershipNo: room.room.guest.membershipNo,
        })),
    [idx, rooms]
  )

  const initialPhoneNumber = initialData.phoneNumber
  const parsedInitialPhoneNumber = initialPhoneNumber
    ? parsePhoneNumberFromString(initialPhoneNumber)
    : undefined
  let initialPhoneNumberCC = initialData.phoneNumberCC
  if (parsedInitialPhoneNumber && !initialPhoneNumberCC) {
    initialPhoneNumberCC = parsedInitialPhoneNumber.country ?? ""
  }
  const methods = useForm({
    defaultValues: {
      countryCode: initialData.countryCode,
      email: initialData.email,
      firstName: initialData.firstName,
      join: initialData.join,
      lastName: initialData.lastName,
      membershipNo: initialData.membershipNo,
      phoneNumber: parsedInitialPhoneNumber?.isValid()
        ? parsedInitialPhoneNumber.nationalNumber
        : initialPhoneNumber,
      phoneNumberCC: initialPhoneNumberCC,
      specialRequest: {
        comment: room.specialRequest.comment,
      },
    },
    criteriaMode: "all",
    mode: "onBlur",
    resolver: zodResolver(getMultiroomDetailsSchema(crossValidationData)),
    reValidateMode: "onChange",
  })

  const {
    handleSubmit,
    trigger,
    control,
    subscribe,
    formState: { isValid },
  } = methods

  useFormTracking("checkout", subscribe, control, ` - room ${roomNr}`)

  useEffect(() => {
    addPreSubmitCallback(`${idx}-details`, trigger)
  }, [addPreSubmitCallback, idx, trigger])

  const updateDetailsStore = useCallback(() => {
    if (isValid) {
      handleSubmit(updateDetails)()
    } else {
      setIncomplete()
    }
  }, [handleSubmit, isValid, setIncomplete, updateDetails])

  useEffect(updateDetailsStore, [updateDetailsStore])

  // Trigger validation of the room manually when another room changes its data.
  // Only do it if the field has a value, to avoid error states before the user
  // has filled anything in.
  useEffect(() => {
    const { firstName, lastName, membershipNo } = methods.getValues()
    if (firstName) {
      methods.trigger("firstName")
    }
    if (lastName) {
      methods.trigger("lastName")
    }
    if (membershipNo) {
      methods.trigger("membershipNo")
    }
  }, [crossValidationData, methods])

  const guestIsGoingToJoin = methods.watch("join")
  const guestIsMember = methods.watch("membershipNo")

  return (
    <FormProvider {...methods}>
      <form
        className={styles.form}
        id={`${formID}-room-${roomNr}`}
        onSubmit={methods.handleSubmit(updateDetails)}
      >
        {guestIsMember ? null : <JoinScandicFriendsCard />}
        <div className={styles.container}>
          <Footnote
            color="uiTextHighContrast"
            textTransform="uppercase"
            type="label"
            className={styles.fullWidth}
          >
            {intl.formatMessage({
              defaultMessage: "Guest information",
            })}
          </Footnote>
          <Input
            label={intl.formatMessage({
              defaultMessage: "First name",
            })}
            maxLength={30}
            name="firstName"
            registerOptions={{
              required: true,
              deps: "lastName",
              onBlur: updateDetailsStore,
            }}
          />
          <Input
            label={intl.formatMessage({
              defaultMessage: "Last name",
            })}
            maxLength={30}
            name="lastName"
            registerOptions={{
              required: true,
              deps: "firstName",
              onBlur: updateDetailsStore,
            }}
          />
          <CountrySelect
            className={styles.fullWidth}
            label={intl.formatMessage({
              defaultMessage: "Country",
            })}
            name="countryCode"
            registerOptions={{ required: true, onBlur: updateDetailsStore }}
          />
          <Input
            className={styles.fullWidth}
            label={intl.formatMessage({
              defaultMessage: "Email address",
            })}
            name="email"
            registerOptions={{ required: true, onBlur: updateDetailsStore }}
          />
          <Phone
            className={styles.fullWidth}
            label={intl.formatMessage({
              defaultMessage: "Phone number",
            })}
            name="phoneNumber"
            registerOptions={{ required: true, onBlur: updateDetailsStore }}
          />
          {guestIsGoingToJoin ? null : (
            <Input
              className={styles.fullWidth}
              label={intl.formatMessage({
                defaultMessage: "Membership ID",
              })}
              name="membershipNo"
              type="tel"
              registerOptions={{ onBlur: updateDetailsStore }}
            />
          )}
          <SpecialRequests registerOptions={{ onBlur: updateDetailsStore }} />
        </div>
        <MemberPriceModal />
      </form>
    </FormProvider>
  )
}
